*To run this program you will first have run the following macros:
	%macro sim_sample()
	%macro data_merge()



options nomprint nomlogic nonotes;

* * ********************************************************************************************;
*    Sanna et al 2011 - "Rising up to higher virtues" (JESP 2011);
* * ********************************************************************************************;

	* STUDY 2 - Time on impossible task;
		%sim_sample(simtot=100000,seed=10001,lbound=0,ubound=35,round_y=0.01,round_m=0.01,round_sd=0.01,n=20,m=11.36,sd=2.84,mk=1);
		%sim_sample(simtot=100000,seed=10002,lbound=0,ubound=35,round_y=0.01,round_m=0.01,round_sd=0.01,n=20,m=6.77,sd=2.84,mk=2);
		%sim_sample(simtot=100000,seed=10003,lbound=0,ubound=35,round_y=0.01,round_m=0.01,round_sd=0.01,n=20,m=8.74,sd=2.84,mk=3);

	* STUDY 3 - grams of hot-sauce;
		%sim_sample(simtot=100000,seed=10004,lbound=0,ubound=340,round_y=0.01,round_m=0.01,round_sd=0.01,n=15,m=39.74,sd=25.11,mk=4);
		%sim_sample(simtot=100000,seed=10005,lbound=0,ubound=340,round_y=0.01,round_m=0.01,round_sd=0.01,n=15,m=85.74,sd=25.11,mk=5);
		%sim_sample(simtot=100000,seed=10006,lbound=0,ubound=340,round_y=0.01,round_m=0.01,round_sd=0.01,n=15,m=65.73,sd=25.11,mk=6);
				*Notes: 
				lower bound for dv is 0, as one could pour 0 hot sauce
				upper bound is 340, the total amount of hot souce available: 12-oz in grams is 340grams)

	* STUDY 4 - # of firsh returned;		
		%sim_sample(simtot=100000,seed=10007,lbound=0,ubound=75,round_y=1,round_m=0.01,round_sd=0.01,n=15,m=32.93,sd=9.54,mk=7);	
		%sim_sample(simtot=100000,seed=10008,lbound=0,ubound=75,round_y=1,round_m=0.01,round_sd=0.01,n=15,m=20.6,sd=9.54,mk=8);	
		%sim_sample(simtot=100000,seed=10009,lbound=0,ubound=75,round_y=1,round_m=0.01,round_sd=0.01,n=15,m=23.66,sd=9.54,mk=9);	
				*Notes;
				*lower bound is returning 0 fish;
				*upper bound is returning 15 fish in every one of 5 rounds->ubound=75;

	
		
	* COMBINES ENTIRE PAPER;
		options notes;
		data all3;
			merge r1-r9;
			*Compute pooled standard deviations by study (SDP);
				sdp_s1=((19*(sd1**2)+19*(sd2**2)+19*(sd3**2))/57)**.5;		*each condition has n=20, so n-1=19, multiplied by var (SD**2);
				sdp_s2=((14*(sd4**2)+14*(sd5**2)+14*(sd6**2))/42)**.5;	    *now n=15, n-1=14;
				sdp_s3=((14*(sd7**2)+14*(sd8**2)+14*(sd9**2))/42)**.5;	

			*Copute SE(SDp) by study with formula of SE(SD)=SD/sqrt(2n);
				sep_s1=sdp_s1/(40**.5);
				sep_s2=sdp_s2/(30**.5);
				sep_s3=sdp_s3/(30**.5);

			*Compute SD(SDs) of each study, and divide by the SE(SDP);
				psi1=round(std(sd1,sd2,sd3)/sep_s1,.0001);
				psi2=round(std(sd4,sd5,sd6)/sep_s2,.0001);
				psi3=round(std(sd7,sd8,sd9)/sep_s3,.0001);
			
			*aggreate three studies via simple average of psi;
				psiall=round(mean(psi1,psi2,psi3),.0001);
				psiall01=round(mean(psi1,psi2,psi3),.01);
		run;
		

		*peek at results;
			proc print data=all3 (obs=10);
			var sd1-sd9 psiall;
			run;
	
%mclear;
	*compute p-values;
		* Each study;
			%pvalue(all3,psi1,  .2378);
			%pvalue(all3,psi2,  .1168);
			%pvalue(all3,psi3,  .1666);
		* all 3 studies;
			%pvalue(all3,psiall,.1737);
	


* ************************************************************
*  Create tabulation of simulations for Figure 2
* ************************************************************;
	proc univariate;
	var psiall01;
	run;
	Data bins;
			do i=1 to 210;
			psiall01=(i-1)/100;
			output;
			end;
	run;
	proc freq noprint data=all3;
		table psiall01/out=f;
	run;
	%data_merge(bins,f,f,psiall01);
	data f;
		set f;
		if count=. then count=0;
	run;
	title 'dchart - Sanna et al. 2011';
	proc print;
	var psiall01 count;
	run;
		
