*SYNTAX;
	*%pvalue(data,sdx,x);
	*sdx: statistic for which we desire to compute p-value (e.g., &sdx=sdm implies we look at the variable sdm in the dataset of frequencies;
	*x: value of statistic we are looking up in the table;

*THIS MACRO TAKES A TABLE RESULTS FROM A SIMULATIONS AND FACILITATES COMPUTING THE P-VALUE

*Dataset contains the frequencies for a given statistic &sdx. ;

%macro pvalue(data,sdx,x);

  *Count how many simulations to then divide by it and get %;
	data _null_;
		if 0 then set &data nobs=nobs;
		call symputx("nobs",nobs);
		stop;
		run;
	
*Add the &x we want the p-value for;
	data sim0;
		&sdx=&x;
		simulation=0;
		output;
	run;
	data &data;
		set &data sim0;
	run;
*Create a table;
	proc freq noprint data=&data;
		table &sdx/out=f outcum;
	run;
*Compute p-value;
	data f;
		set f;
		*compute;
			pvalue=(cum_freq-count/2)/&nobs;
		*highlight obtained stat;
		if &sdx=&x then thisone="<-----";
	
		* drop;
			drop cum_pct  percent;
	run;
	title "pvalue &sdx = &x";
	proc print data=f;
	where &sdx<=&x+.002;
	*Where pvalue<=.15;
	*where &sdx<=&x;
	run;
*Delete the obs with x we addded;
	data &data;
		set &data;
		if simulation=0 then delete;
	run;


	%mend;
	
